package de.laliluna.tutorial.databaseview;

import java.rmi.RemoteException;
import java.util.Collection;
import java.util.Iterator;
import java.util.Properties;

import javax.ejb.CreateException;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import de.laliluna.tutorial.databaseview.entity.interfaces.BookViewValue;
import de.laliluna.tutorial.databaseview.session.interfaces.BookViewSession;
import de.laliluna.tutorial.databaseview.session.interfaces.BookViewSessionHome;

/**
 * @author http://www.laliluna.de
 */
public class TestView {

    Properties properties;

    public TestView() {
        properties = new Properties();
        properties.put("java.naming.factory.initial",
                       "org.jnp.interfaces.NamingContextFactory");
        properties.put("java.naming.factory.url.pkgs",
                       "org.jboss.naming:org.jnp.interfaces");
        properties.put("java.naming.provider.url", "jnp://localhost:1099");
        properties.put("jnp.disableDiscovery", "true");
    }

    public static void main(String[] args) {
        TestView testView = new TestView();
        // call the testEJB method
        testView.testEJB();
    }
    
    public void testEJB(){
        
        try {
            InitialContext context = new InitialContext(properties);

            // get the session home interface 
            BookViewSessionHome sessionHome = (BookViewSessionHome) context
                    .lookup(BookViewSessionHome.JNDI_NAME);

            // create a session object
            BookViewSession session = sessionHome.create();

            // output data
            Collection collection = session.getAll();
            for (Iterator iter = collection.iterator(); iter.hasNext();) {
                BookViewValue element = (BookViewValue) iter.next();
                System.out.print(element.getId() + ", ");
                System.out.print(element.getTitle() + ", ");
            }

        } catch (CreateException e) {
            e.printStackTrace();
        } catch (RemoteException e) {
            e.printStackTrace();
        } catch (NamingException e) {
            e.printStackTrace();
        }
    }
}